package com.ruoyi.ehsMaterial.controller;

import java.util.List;
import java.util.Arrays;
import javax.servlet.http.HttpServletResponse;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.ehsMaterial.domain.EhsMaterial;
import com.ruoyi.ehsMaterial.service.IEhsMaterialService;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.common.core.page.TableDataInfo;

/**
 * 物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”Controller
 *
 * @author ruoyi
 * @date 2023-12-04
 */
@Api(tags="物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”管理")
@RestController
@RequestMapping("/ehsMaterial/ehsMaterial")
public class EhsMaterialController extends BaseController
{
    @Autowired
    private IEhsMaterialService ehsMaterialService;

    /**
     * 查询物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”列表
     */
    @PreAuthorize("@ss.hasPermi('ehsMaterial:ehsMaterial:list')")
    @GetMapping("/list")
    public TableDataInfo list(EhsMaterial ehsMaterial)
    {
        startPage();
        List<EhsMaterial> list = ehsMaterialService.selectEhsMaterialList(ehsMaterial);
        return getDataTable(list);
    }

    /**
     * 导出物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”列表
     */
    @PreAuthorize("@ss.hasPermi('ehsMaterial:ehsMaterial:export')")
    @Log(title = "物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, EhsMaterial ehsMaterial)
    {
        List<EhsMaterial> list = ehsMaterialService.selectEhsMaterialList(ehsMaterial);
        ExcelUtil<EhsMaterial> util = new ExcelUtil<EhsMaterial>(EhsMaterial.class);
        util.exportExcel(response, list, "物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”数据");
    }

    /**
     * 获取物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”详细信息
     */
    @PreAuthorize("@ss.hasPermi('ehsMaterial:ehsMaterial:query')")
    @GetMapping(value = "/{materialId}")
    public AjaxResult getInfo(@PathVariable("materialId") Long materialId)
    {
        return success(ehsMaterialService.selectEhsMaterialByMaterialId(materialId));
    }

    /**
     * 新增物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”
     */
    @ApiOperation("新增物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”")
    @PreAuthorize("@ss.hasPermi('ehsMaterial:ehsMaterial:add')")
    @Log(title = "物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody EhsMaterial ehsMaterial)
    {
        return toAjax(ehsMaterialService.save(ehsMaterial));
    }

    /**
     * 修改物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”
     */
    @ApiOperation("修改物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”")
    @PreAuthorize("@ss.hasPermi('ehsMaterial:ehsMaterial:edit')")
    @Log(title = "物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody EhsMaterial ehsMaterial)
    {
        return toAjax(ehsMaterialService.updateById(ehsMaterial));
    }

    /**
     * 删除物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”
     */
    @ApiOperation("删除物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”")
    @PreAuthorize("@ss.hasPermi('ehsMaterial:ehsMaterial:remove')")
    @Log(title = "物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”", businessType = BusinessType.DELETE)
    @DeleteMapping("/{materialIds}")
    public AjaxResult remove(@PathVariable Long[] materialIds)
    {
        return toAjax(ehsMaterialService.removeByIds(Arrays.asList(materialIds)));
    }
}